<template>
  <a-layout>
    <a-layout-content style="padding: 0;">
      <a-card class="box-card" style="flex: 1; overflow-y: auto; padding: 0 !important;">
        <pblm-query-terms ref="queryTerms" :showRectifyStatus="false" :showAd="false" @queryByParams="queryByParams" />
        <a-row type="flex" justify="space-between" style="border-top:1px solid #0014ff2e;">
          <!-- <a-col :span="24" class="el-row-operation">
            <a-button
              @click="openActivityCommentDialog(0, $event)"
              :disabled="loading"
              size="small"
              type="primary"
              style="color:rgba(255,255,255,1);float:left;margin-right:10px;">退回修改</a-button>
            <a-button
              @click="openActivityCommentDialog(1, $event)"
              :disabled="loading"
              size="small"
              type="primary"
              style="color:rgba(255,255,255,1);float:left;margin-right:10px;">同意上报</a-button>
          </a-col> -->
        </a-row>
        <pblm-table
          ref="sjdwPblmTable"
          :pblmTableSetting="sjdwDoubleApproveTableSetting"
          @pageChange="handlePageChange"
          @sizeChange="handleSizeChange"
          @refreshTable="refreshTable"
          @selectionChange="handleSelectionChange" />
        <a-modal
          :open="showRectifyUnitDialog"
          @ok="getOk"
          @cancel="closeRectifyUnitDialog"
          title="指派整改单位"
          width="60%"
          class="outerDialog custom_dialog">
          <pblm-rectify-unit ref="rectifyUnitInfoDialog" @saveRectifyUnitInfo="saveRectifyUnitInfo" />
          <span slot="okText">提交</span>
        </a-modal>
        <activity-comment
          v-if="showActivityCommentDialog"
          :isAg="this.isAg"
          :activityName="this.actName"
          @saveActivityComment="saveActivityComment"
          @closeActivityCommentDialog="closeActivityCommentDialog" />
      </a-card>
    </a-layout-content>
  </a-layout>
</template>

<script>
import moment from 'moment';
import { formatDateTime2 } from '../../utils/gw_date';
import {
  approvedPblmRectify,
  distributePblmToSpecificOrg,
  formatPblms,
  redistributePblmToSpecificOrg,
  rejectPblmRectify,
  requestPblmListByQueryParams,
  requestPendingApprovePblm,
} from './Common/rectify_api';
import { formatDeadLineDate } from './Common/rectify_date';
import ActivityComment from './Components/ActivityComment.vue';
import pblmQueryTerms from './Components/pblmQueryTerms';
import pblmRectifyUnit from './Components/pblmRectifyUnit';
import pblmTable from './Components/pblmTable';
export default {
  name: 'SjdwDoubleApprovePblm',
  props: [],
  components: {
    pblmQueryTerms,
    pblmTable,
    pblmRectifyUnit,
    ActivityComment,
  },
  data() {
    return {
      moment,
      loading: false,
      showRectifyUnitDialog: false,
      currentWorkflowStat: '24-1', // 整改状态 24-1=市级单位内部复核
      queryParams: {
        hasVedio: '',
        adCode: '',
        pblmStat: '',
        inspPblmCate: '',
        ifCasePblm: '',
        nm: '',
        rsName: '',
        adFullName: '',
        startTime: '',
        endTime: '',
        objType: '', // 为空才能不区分督查类别
        inspPblmName: '',
        dataStat: '2', // 整改阶段必须为2
        persId: localStorage.getItem('persId'),
        villType: '0',
        pageSize: 10,
        pageNum: 1,
        pblmTotal: 0,
        pTypeCode: '', // 督查类别
        pYear: '', // 年度
        zgXianOrgId: null, // 接收单位
        zgWh: '', // 整改文号
        workflowStat: '24-1', // important 仅获取待市级单位审批的问题
        schdYear: moment(new Date().getFullYear().toString()).format('YYYY'),
      },
      sjdwDoubleApproveTableSetting: {
        adType: false,
        data: [], // 主数据源
        isShowBtn: 6,
        pagination: {
          pageSize: 10,
          pageNum: 1,
          pblmCount: 0,
        }, // 翻页相关配置项
        height: 500,
        currentPblmId: '', // 当前选中的问题的ID
        selectedPblms: {}, // 多选模式下选中的所有问题集合
        multiSelect: true, // 是否出现行复选框
        enablePblmRectifyInfo: false, // 操作栏是否有整改信息输入按钮
      },
      showActivityCommentDialog: false,
      isAg: 1, // 流程流转方向 0-正常向后 1=正常向前 2=列入调度清单
      actName: '', // 流程流转方向名称
    };
  },
  created() {
    this.queryParams.workflowStat = this.currentWorkflowStat; // important 使用当前流程状态码来获取对应的问题列表
    this.getDoubleApprovePblm();
  },
  mounted() {
    this.$nextTick(function () {
      this.sjdwDoubleApproveTableSetting.height =
        document.getElementsByClassName('ant-tabs')[0].offsetHeight - 260;
    });
  },
  computed: {
    formatDateTime() {
      return formatDateTime2;
    },
    formatDeadLineDate() {
      return formatDeadLineDate;
    },
  },
  methods: {
    refreshTable() {
      console.log('刷新表格数据');
      this.getDoubleApprovePblm(); // 重新加载数据
    },
    getOk() {
      this.$refs.rectifyUnitInfoDialog.saveRectifyUnitInfo();
    },
    // 按指定条件获取待下发问题列表数据
    queryByParams(val) {
      this.queryParams = val.queryParams;
      this.queryParams.workflowStat = this.currentWorkflowStat; // important 获取待市级单位审批的问题
      this.$refs.sjdwPblmTable.clearSelection(); // 清空原有的选中行信息
      this.getDoubleApprovePblm();
    },
    // 获取待下发问题列表数据
    getDoubleApprovePblm() {
      this.loading = true;
      this.queryParams.pageSize =
        this.sjdwDoubleApproveTableSetting.pagination.pageSize;
      this.queryParams.pageNum =
        this.sjdwDoubleApproveTableSetting.pagination.pageNum;
      requestPblmListByQueryParams(this.queryParams).then((res) => {
        this.loading = false;
        if (res.data !== null) {
          this.sjdwDoubleApproveTableSetting.data = res.data.list;
          /*  this.sjdwDoubleApproveTableSetting.data.sort(function (x, y) {
              return x.zgDate - y.zgDate;
            }); */
          this.sjdwDoubleApproveTableSetting.pagination.pblmCount =
            res.data.total;
        } else {
          this.sjdwDoubleApproveTableSetting.data = [];
          this.sjdwDoubleApproveTableSetting.pagination.pblmCount = 0;
        }
      });
    },
    // 直接页数跳转
    handlePageChange(val) {
      this.sjdwDoubleApproveTableSetting.pagination.pageNum = val.pageNum;
      this.getDoubleApprovePblm();
    },
    // 调整每页显示记录数
    handleSizeChange(val) {
      this.sjdwDoubleApproveTableSetting.pagination.pageSize = val.pageSize;
      this.getDoubleApprovePblm();
    },
    // 选中行时获取所有已选中行
    handleSelectionChange(val) {
      this.sjdwDoubleApproveTableSetting.selectedPblms = val.selectedPblms;
    },

    openReassignRectifyUnitDialog() {
      if (this.sjdwDoubleApproveTableSetting.selectedPblms.length > 0) {
        this.showRectifyUnitDialog = true;
      } else {
        this.$message.warning('请选择需要重新指派整改单位的问题!');
      }
    },
    // 关闭下派单位选择窗口
    closeRectifyUnitDialog() {
      this.showRectifyUnitDialog = false;
    },
    saveRectifyUnitInfo(val) {
      this.showRectifyUnitDialog = false;
      if (this.sjdwDoubleApproveTableSetting.selectedPblms.length > 0) {
        for (
          let i = 0;
          i < this.sjdwDoubleApproveTableSetting.selectedPblms.length;
          i++
        ) {
          this.sjdwDoubleApproveTableSetting.selectedPblms[i].zgXianOrgId =
            val.zgXianOrgId;
          this.sjdwDoubleApproveTableSetting.selectedPblms[i].zgXianOrgMemo =
            val.zgXianOrgMemo;
        }
        redistributePblmToSpecificOrg(
          this.sjdwDoubleApproveTableSetting.selectedPblms,
        ).then((res) => {
          if (res.success) {
            this.loading = false;
            this.$message.success('重新指派成功!');
            this.$refs.sjdwPblmTable.clearSelection(); // 清空原有的选中行信息
            this.getDoubleApprovePblm();
          } else {
            this.$message.error(res.message);
          }
        });
      } else {
        this.$message.warning('请选择需要操作的问题!');
      }
    },
    openActivityCommentDialog(isAg, e) {
      if (this.sjdwDoubleApproveTableSetting.selectedPblms.length > 0) {
        this.isAg = isAg;
        this.actName = e.currentTarget.innerText;
        this.showActivityCommentDialog = true;
      } else {
        this.$message.warning('请选择需要操作的问题!');
      }
    },
    closeActivityCommentDialog() {
      this.showActivityCommentDialog = false;
    },
    saveActivityComment(val) {
      this.closeActivityCommentDialog();
      this.approveSelectedPblm(val.isAg, val.Comment);
    },
    // 驱动整改流程流转
    approveSelectedPblm(isAg, activityComment) {
      if (this.sjdwDoubleApproveTableSetting.selectedPblms.length > 0) {
        this.loading = true;
        approvedPblmRectify(
          formatPblms(
            this.sjdwDoubleApproveTableSetting.selectedPblms,
            isAg,
            activityComment,
          ),
        ).then((res) => {
          if (res.success) {
            this.loading = false;
            this.$message.success('操作已完成!');
            this.$refs.sjdwPblmTable.clearSelection(); // 清空原有的选中行信息
            this.getDoubleApprovePblm();
          } else {
            this.$message.error(res.message);
          }
        });
      } else {
        this.$message.warning('请选择需要操作的问题!');
      }
    },
  },
};
</script>

<style lang='less' scoped>

</style>
